"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NativeIconTextButton = exports.NativeButton = exports.IconTextButton = exports.IconButton = exports.Button = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _reactHooksShareable = require("react-hooks-shareable");

var _Icon = require("../Icon");

var _Typography = require("../Typography");

var _designparams = require("../designparams");

var _excluded = ["disabled", "type", "variant", "accent", "icon", "onPointerDown", "onPointerUp", "onFocus", "label"],
    _excluded2 = ["disabled", "type", "variant", "accent", "onPointerDown", "onPointerUp", "onFocus", "icon"],
    _excluded3 = ["disabled", "type", "icon", "onPointerDown", "onPointerUp", "onFocus", "label"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// Button min-width should be "Cancel" button width
var BUTTON_MIN_WIDTH = '83px'; //Common CSS for NativeButton and NativeIconTextButton

var COMMON_STYLE = (0, _styledComponents.css)(["vertical-align:middle;white-space:nowrap;height:", ";outline:none;&::-moz-focus-inner{border:0;}border-radius:", ";cursor:pointer;user-select:none;transition:all 200ms;max-width:100%;"], _designparams.componentSize.small, _designparams.shape.radius.small);
/**
 * Button
 *
 * It has variant `primary` or `secondary`.
 * Default variant is `primary`.
 * `secondary` button change its color if `accent` property is true.
 *
 */

var NativeButton = _styledComponents.default.button.withConfig({
  displayName: "Button__NativeButton",
  componentId: "sc-k93rwb-0"
})(["", " min-width:", ";border:2px solid transparent;padding:", ";", " ", ""], COMMON_STYLE, BUTTON_MIN_WIDTH, _ref => {
  var {
    icon
  } = _ref;
  return icon === undefined ? "0 ".concat(_designparams.spacing.large) : "0 ".concat(_designparams.spacing.large, " 0 ").concat(_designparams.spacing.medium);
}, _ref2 => {
  var {
    variant,
    accent,
    visibleFocus,
    theme
  } = _ref2;

  if (variant === 'primary') {
    return (0, _styledComponents.css)(["color:", ";fill:", ";background-color:", ";box-shadow:", ";&:hover{background-color:", ";box-shadow:", ";}&:focus{", ";}&:active{background-color:", ";box-shadow:0 0 0 4px ", ";}&:disabled{background-color:", ";}"], theme.color.text00(), theme.color.text00(), theme.color.elementPrimary(), theme.shadow.primaryButton, theme.color.textPrimary(), theme.shadow.primaryButton, visibleFocus ? (0, _styledComponents.css)(["background-color:", ";box-shadow:", ";border:2px solid ", ";"], theme.color.elementPrimary(), theme.shadow.primaryButton, theme.color.textPrimary()) : undefined, theme.color.textPrimary(), theme.color.elementPrimary(_designparams.opacity[24]), theme.color.elementPrimary());
  } else if (accent) {
    return (0, _styledComponents.css)(["color:", ";fill:", ";background-color:transparent;&:hover{color:", ";background-color:", ";}&:focus{", ";}&:active{color:", ";background-color:", ";}&:disabled{color:", ";fill:", ";background-color:transparent;}"], theme.color.elementPrimary(), theme.color.elementPrimary(), theme.color.textPrimary(), theme.color.elementPrimary(_designparams.opacity[16]), visibleFocus ? (0, _styledComponents.css)(["color:", ";background-color:", ";border:2px solid ", ";"], theme.color.elementPrimary(), theme.color.elementPrimary(_designparams.opacity[16]), theme.color.elementBorder()) : undefined, theme.color.textPrimary(), theme.color.elementPrimary(_designparams.opacity[24]), theme.color.elementPrimary(), theme.color.elementPrimary());
  }

  return (0, _styledComponents.css)(["color:", ";fill:", ";background-color:transparent;&:hover{color:", ";background-color:", ";}&:focus{", ";}&:active{color:", ";background-color:", ";}&:disabled{color:", ";fill:", ";background-color:transparent;}"], theme.color.text04(), theme.color.text04(), theme.color.text03(), theme.color.element11(_designparams.opacity[16]), visibleFocus ? (0, _styledComponents.css)(["color:", ";background-color:", ";border:2px solid ", ";"], theme.color.text04(), theme.color.element11(_designparams.opacity[16]), theme.color.elementBorder()) : undefined, theme.color.text03(), theme.color.element11(_designparams.opacity[24]), theme.color.text04(), theme.color.text04());
}, _ref3 => {
  var {
    disabled
  } = _ref3;
  return disabled === true ? (0, _styledComponents.css)(["opacity:", ";cursor:default;box-shadow:none;&:hover,active,focus{box-shadow:none;border:2px solid transparent;}"], _designparams.opacity[48]) : undefined;
});

exports.NativeButton = NativeButton;

var Container = _styledComponents.default.span.attrs({
  className: 'sc-Container'
}).withConfig({
  displayName: "Button__Container",
  componentId: "sc-k93rwb-1"
})(["width:100%;display:flex;align-items:center;justify-content:center;"]);

var ButtonIcon = (0, _styledComponents.default)(_Icon.Icon).attrs({
  className: 'sc-ButtonIcon'
}).withConfig({
  displayName: "Button__ButtonIcon",
  componentId: "sc-k93rwb-2"
})(["fill:inherit;flex:none;", ""], _ref4 => {
  var {
    addSpace
  } = _ref4;
  return addSpace ? (0, _styledComponents.css)(["margin-right:", ";"], _designparams.spacing.medium) : undefined;
});

var LabelContainer = _styledComponents.default.span.attrs({
  className: 'sc-LabelContainer'
}).withConfig({
  displayName: "Button__LabelContainer",
  componentId: "sc-k93rwb-3"
})(["overflow:hidden;text-overflow:ellipsis;pointer-events:none;color:inherit;text-transform:", ";"], _ref5 => {
  var {
    variant,
    accent,
    theme
  } = _ref5;

  if (variant === 'primary') {
    return theme.font.button.primary.textTransform;
  } else if (accent) {
    return theme.font.button.secondary.accent.textTransform;
  }

  return theme.font.button.secondary.default.textTransform;
});

/* eslint-disable-next-line react/display-name */
var Button = /*#__PURE__*/_react.default.forwardRef((_ref6, ref) => {
  var {
    disabled = false,
    type = 'button',
    variant = 'primary',
    accent = false,
    icon,
    onPointerDown,
    onPointerUp,
    onFocus,
    label
  } = _ref6,
      props = _objectWithoutProperties(_ref6, _excluded);

  var {
    isPointerOn,
    isPointerOff,
    determineVisibleFocus,
    visibleFocus
  } = (0, _reactHooksShareable.useVisibleFocus)();
  var handleFocus = (0, _react.useCallback)(e => {
    onFocus === null || onFocus === void 0 ? void 0 : onFocus(e);
    determineVisibleFocus();
  }, [determineVisibleFocus, onFocus]);
  var handlePointerDown = (0, _react.useCallback)(e => {
    onPointerDown === null || onPointerDown === void 0 ? void 0 : onPointerDown(e);
    isPointerOn();
  }, [isPointerOn, onPointerDown]);
  var handlePointerUp = (0, _react.useCallback)(e => {
    onPointerUp === null || onPointerUp === void 0 ? void 0 : onPointerUp(e);
    isPointerOff();
  }, [isPointerOff, onPointerUp]);
  return /*#__PURE__*/_react.default.createElement(NativeButton, _extends({
    ref: ref,
    disabled: disabled,
    type: type,
    variant: variant,
    accent: accent,
    icon: icon,
    onPointerDown: handlePointerDown,
    onPointerUp: handlePointerUp,
    onFocus: handleFocus
  }, props, {
    visibleFocus: visibleFocus
  }), /*#__PURE__*/_react.default.createElement(Container, null, icon !== undefined ? /*#__PURE__*/_react.default.createElement(ButtonIcon, {
    icon: icon,
    addSpace: true
  }) : undefined, /*#__PURE__*/_react.default.createElement(LabelContainer, {
    variant: variant,
    accent: accent
  }, /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
    variant: "button-text"
  }, label))));
});
/*
 * IconButton
 *
 * It has variant `primary` or `secondary`.
 * Default variant is `primary`.
 *
 * `secondary` IconButton has Halo background that become bigger on active state
 * than on hover state. And it changes its color if `accent` property is true.
 *
 */


exports.Button = Button;
var IconNativeButton = (0, _styledComponents.default)(NativeButton).withConfig({
  displayName: "Button__IconNativeButton",
  componentId: "sc-k93rwb-4"
})(["position:relative;flex:none;height:", ";width:", ";min-width:unset;padding:unset;", ""], _designparams.componentSize.small, _designparams.componentSize.small, _ref7 => {
  var {
    variant,
    accent,
    visibleFocus,
    theme
  } = _ref7;

  if (variant === 'primary') {
    return undefined;
  } else if (accent) {
    return (0, _styledComponents.css)(["background-color:transparent;border-radius:", ";&:hover{background-color:transparent;border:0 solid transparent;", "{background-color:", ";transform:scale(1);}}&:focus{", "}&:active{background-color:transparent;", "{background-color:", ";transform:scale(1.06);}}"], _designparams.shape.radius.circle, IconButtonHalo, theme.color.elementPrimary(_designparams.opacity[16]), visibleFocus ? (0, _styledComponents.css)(["background-color:transparent;border:2px solid ", ";", "{background-color:", ";transform:scale(1);}"], theme.color.elementBorder(), IconButtonHalo, theme.color.elementPrimary(_designparams.opacity[16])) : undefined, IconButtonHalo, theme.color.elementPrimary(_designparams.opacity[24]));
  }

  return (0, _styledComponents.css)(["background-color:transparent;border-radius:", ";&:hover{background-color:transparent;border:0 solid transparent;", "{background-color:", ";transform:scale(1);}}&:focus{", "}&:active{background-color:transparent;", "{background-color:", ";transform:scale(1.06);}}"], _designparams.shape.radius.circle, IconButtonHalo, theme.color.element11(_designparams.opacity[16]), visibleFocus ? (0, _styledComponents.css)(["background-color:transparent;border:2px solid ", ";", "{background-color:", ";transform:scale(1);}"], theme.color.elementBorder(), IconButtonHalo, theme.color.element11(_designparams.opacity[16])) : undefined, IconButtonHalo, theme.color.element11(_designparams.opacity[24]));
});

var IconButtonHalo = _styledComponents.default.div.withConfig({
  displayName: "Button__IconButtonHalo",
  componentId: "sc-k93rwb-5"
})(["position:absolute;top:0;right:0;bottom:0;left:0;border-radius:", ";background-color:transparent;outline:none;transform:scale(0.3);transition:transform 100ms;"], _designparams.shape.radius.circle);

/* eslint-disable-next-line react/display-name */
var IconButton = /*#__PURE__*/_react.default.forwardRef((_ref8, ref) => {
  var {
    disabled,
    type = 'button',
    variant = 'primary',
    accent = false,
    onPointerDown,
    onPointerUp,
    onFocus,
    icon
  } = _ref8,
      props = _objectWithoutProperties(_ref8, _excluded2);

  var {
    isPointerOn,
    isPointerOff,
    determineVisibleFocus,
    visibleFocus
  } = (0, _reactHooksShareable.useVisibleFocus)();
  var handleFocus = (0, _react.useCallback)(e => {
    onFocus === null || onFocus === void 0 ? void 0 : onFocus(e);
    determineVisibleFocus();
  }, [determineVisibleFocus, onFocus]);
  var handlePointerDown = (0, _react.useCallback)(e => {
    onPointerDown === null || onPointerDown === void 0 ? void 0 : onPointerDown(e);
    isPointerOn();
  }, [isPointerOn, onPointerDown]);
  var handlePointerUp = (0, _react.useCallback)(e => {
    onPointerUp === null || onPointerUp === void 0 ? void 0 : onPointerUp(e);
    isPointerOff();
  }, [isPointerOff, onPointerUp]);
  return /*#__PURE__*/_react.default.createElement(IconNativeButton, _extends({
    ref: ref,
    disabled: disabled,
    type: type,
    variant: variant,
    accent: accent,
    onPointerDown: handlePointerDown,
    onPointerUp: handlePointerUp,
    onFocus: handleFocus
  }, props, {
    visibleFocus: visibleFocus
  }), /*#__PURE__*/_react.default.createElement(ButtonIcon, {
    icon: icon,
    addSpace: false
  }), variant === 'secondary' ? /*#__PURE__*/_react.default.createElement(IconButtonHalo, {
    accent: accent
  }) : undefined);
});
/**
 * IconTextButton
 *
 * Always has a primary icon and a secondary text
 *
 */


exports.IconButton = IconButton;

var NativeIconTextButton = _styledComponents.default.button.withConfig({
  displayName: "Button__NativeIconTextButton",
  componentId: "sc-k93rwb-6"
})(["", " border:none;padding:0 ", " 0 0;", ""], COMMON_STYLE, _designparams.spacing.large, _ref9 => {
  var {
    visibleFocus,
    theme
  } = _ref9;
  return (0, _styledComponents.css)(["color:", ";fill:", ";background-color:transparent;&:hover{color:", ";background-color:", ";", "{background-color:", ";}}&:focus{", ";}&:active{box-shadow:0 0 0 4px ", ";background-color:", ";}&:disabled{opacity:", ";cursor:default;box-shadow:none;&:hover{", "{background-color:", ";}}}"], theme.color.text04(), theme.color.text04(), theme.color.text03(), theme.color.element11(_designparams.opacity[16]), IconContainer, theme.color.textPrimary(), visibleFocus ? (0, _styledComponents.css)(["color:", ";background-color:", ";"], theme.color.text04(), theme.color.element11(_designparams.opacity[16])) : undefined, theme.color.elementPrimary(_designparams.opacity[24]), theme.color.element11(_designparams.opacity[24]), _designparams.opacity[48], IconContainer, theme.color.elementPrimary());
});

exports.NativeIconTextButton = NativeIconTextButton;
var IconContainer = (0, _styledComponents.default)(_Icon.Icon).withConfig({
  displayName: "Button__IconContainer",
  componentId: "sc-k93rwb-7"
})(["", ""], _ref10 => {
  var {
    theme
  } = _ref10;
  return (0, _styledComponents.css)(["box-sizing:border-box;height:", ";width:", ";color:", ";background-color:", ";border-radius:", ";margin-right:", ";padding:", ";transition:all 200ms;"], _designparams.componentSize.small, _designparams.componentSize.small, theme.color.text00(), theme.color.elementPrimary(), _designparams.shape.radius.small, _designparams.spacing.medium, _designparams.spacing.small);
});

// eslint-disable-next-line react/display-name
var IconTextButton = /*#__PURE__*/_react.default.forwardRef((_ref11, ref) => {
  var {
    disabled = false,
    type = 'button',
    icon,
    onPointerDown,
    onPointerUp,
    onFocus,
    label
  } = _ref11,
      props = _objectWithoutProperties(_ref11, _excluded3);

  var {
    isPointerOn,
    isPointerOff,
    determineVisibleFocus,
    visibleFocus
  } = (0, _reactHooksShareable.useVisibleFocus)();
  var handleFocus = (0, _react.useCallback)(e => {
    onFocus === null || onFocus === void 0 ? void 0 : onFocus(e);
    determineVisibleFocus();
  }, [determineVisibleFocus, onFocus]);
  var handlePointerDown = (0, _react.useCallback)(e => {
    onPointerDown === null || onPointerDown === void 0 ? void 0 : onPointerDown(e);
    isPointerOn();
  }, [isPointerOn, onPointerDown]);
  var handlePointerUp = (0, _react.useCallback)(e => {
    onPointerUp === null || onPointerUp === void 0 ? void 0 : onPointerUp(e);
    isPointerOff();
  }, [isPointerOff, onPointerUp]);
  return /*#__PURE__*/_react.default.createElement(NativeIconTextButton, _extends({
    ref: ref,
    disabled: disabled,
    type: type,
    onPointerDown: handlePointerDown,
    onPointerUp: handlePointerUp,
    onFocus: handleFocus
  }, props, {
    visibleFocus: visibleFocus
  }), /*#__PURE__*/_react.default.createElement(Container, null, /*#__PURE__*/_react.default.createElement(IconContainer, {
    icon: icon
  }), /*#__PURE__*/_react.default.createElement(LabelContainer, {
    variant: "primary",
    accent: false
  }, /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
    variant: "button-text"
  }, label))));
});

exports.IconTextButton = IconTextButton;