"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BaseChip = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Icon = require("../Icon");

var _designparams = require("../designparams");

var _icons = require("./icons");

var _excluded = ["error", "disabled", "component"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ChipArea = _styledComponents.default.div.withConfig({
  displayName: "BaseChip__ChipArea",
  componentId: "sc-1sgxnvr-0"
})(["position:relative;box-sizing:border-box;user-select:none;height:", ";width:min-content;min-width:", ";max-width:100%;padding:0 ", ";display:flex;align-items:center;overflow:hidden;border-radius:", ";color:", ";background-color:", ";", ";", ";"], _designparams.componentSize.mini, _ref => {
  var {
    error
  } = _ref;
  return error ? _designparams.componentSize.extraLarge : _designparams.componentSize.small;
}, _designparams.spacing.medium, _designparams.shape.radius.small, _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.text01();
}, _ref3 => {
  var {
    error,
    theme
  } = _ref3;
  return error ? theme.color.backgroundError() : theme.color.background01();
}, _ref4 => {
  var {
    disabled
  } = _ref4;
  return disabled ? (0, _styledComponents.css)(["opacity:", ";"], _designparams.opacity[48]) : undefined;
}, _ref5 => {
  var {
    error,
    theme
  } = _ref5;
  return error ? (0, _styledComponents.css)(["color:", ";padding-left:0;border:1px solid ", ";"], theme.color.textError(), theme.color.elementError()) : undefined;
});

var ChipErrorIcon = (0, _styledComponents.default)(_Icon.Icon).attrs({
  icon: _icons.ErrorWithoutCircleIcon
}).withConfig({
  displayName: "BaseChip__ChipErrorIcon",
  componentId: "sc-1sgxnvr-1"
})(["flex:0 0 min-content;overflow:visible;color:", ";"], _ref6 => {
  var {
    theme
  } = _ref6;
  return theme.color.elementError();
});

/* eslint-disable-next-line react/display-name */
var BaseChip = /*#__PURE__*/_react.default.forwardRef((_ref7, ref) => {
  var {
    error = false,
    disabled = false,
    component
  } = _ref7,
      props = _objectWithoutProperties(_ref7, _excluded);

  return /*#__PURE__*/_react.default.createElement(ChipArea, _extends({
    ref: ref,
    error: error,
    disabled: disabled
  }, props), error ? /*#__PURE__*/_react.default.createElement(ChipErrorIcon, null) : null, component);
});

exports.BaseChip = BaseChip;