export * from './BaseChip';
import React from 'react';
import { IconType } from '../Icon';
import { BaseChipProps } from './BaseChip';
export interface ChipProps extends Omit<BaseChipProps, 'component' | 'noPadding'> {
    /**
     * Changes the text of the label displayed on the chip.
     */
    readonly text: string;
    /**
     * Optional icon next to text when no error
     */
    readonly icon?: IconType;
    /**
     * Function to call if remove icon is pressed. Remove icon
     * only visible if this prop is set.
     */
    readonly onRemove?: (e: React.MouseEvent) => void;
}
export declare const Chip: React.ForwardRefExoticComponent<ChipProps & React.RefAttributes<HTMLDivElement>>;
